//this source code was auto-generated by tolua#, do not modify it
using System;
using LuaInterface;

public class CLASSTAG_CGPlayerWrap
{
	public static void Register(LuaState L)
	{
		L.BeginClass(typeof(CGPlayer), typeof(UnityEngine.MonoBehaviour));
#if !UNITY_STANDALONE
		L.RegFunction("SetPlayMode",FUNCTAG_SetPlayMode);
#endif
		L.RegFunction("PlayCG",FUNCTAG_PlayCG);
		L.RegFunction("IsSkipCG",FUNCTAG_IsSkipCG);
		L.EndClass();
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_PlayCG(IntPtr L)
	{
		try
		{
			int count = LuaDLL.lua_gettop(L);

			if (count == 2 && TypeChecker.CheckTypes(L, 1, typeof(string), typeof(System.Action)))
			{
				string arg0 = ToLua.ToString(L, 1);
				System.Action arg1 = null;
				LuaTypes funcType2 = LuaDLL.lua_type(L, 2);

				if (funcType2 != LuaTypes.LUA_TFUNCTION)
				{
					 arg1 = (System.Action)ToLua.ToObject(L, 2);
				}
				else
				{
					LuaFunction func = ToLua.ToLuaFunction(L, 2);
					arg1 = DelegateFactory.CreateDelegate(typeof(System.Action), func) as System.Action;
				}

				UnityEngine.GameObject o = CGPlayer.PlayCG(arg0, arg1);
				ToLua.Push(L, o);
				return 1;
			}
			else if (count == 2 && TypeChecker.CheckTypes(L, 1, typeof(string), typeof(LuaInterface.LuaFunction)))
			{
				string arg0 = ToLua.ToString(L, 1);
				LuaFunction arg1 = ToLua.ToLuaFunction(L, 2);
				CGPlayer.PlayCG(arg0, arg1);
				return 0;
			}
			else
			{
				return LuaDLL.luaL_throw(L, "invalid arguments to method: CGPlayer.PlayCG");
			}
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_IsSkipCG(IntPtr L)
	{
		try
		{
			LuaDLL.lua_pushboolean(L, CGPlayer.skipcg);
			return 1;
		}
		catch (Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}

#if !UNITY_STANDALONE
	[MonoPInvokeCallbackAttribute(typeof(LuaCSFunction))]
	static int FUNCTAG_SetPlayMode(IntPtr L)
	{
		try
		{
			ToLua.CheckArgsCount(L, 1);
			UnityEngine.FullScreenMovieControlMode arg0 = (UnityEngine.FullScreenMovieControlMode)(int)LuaDLL.lua_tonumber(L, 1);
			CGPlayer.SetPlayMode(arg0);
			return 0;
		}
		catch(Exception e)
		{
			return LuaDLL.toluaL_exception(L, e);
		}
	}
#endif
}

